---
title: CountQueuingStrategy
slug: Web/API/CountQueuingStrategy
tags:
  - API
  - CountQueuingStrategy
  - Experimental
  - Interface
  - Reference
  - Streams
---
<p>{{SeeCompatTable}}{{APIRef("Streams")}}</p>

<p>The <strong><code>CountQueuingStrategy</code></strong> interface of the <a href="/en-US/docs/Web/API/Streams_API">Streams API</a> provides a built-in chunk counting queuing strategy that can be used when constructing streams.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("CountQueuingStrategy.CountQueuingStrategy", "CountQueuingStrategy()")}}</dt>
 <dd>Creates a new <code>CountQueuingStrategy</code> object instance.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p>None.</p>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("CountQueuingStrategy.size()")}}</dt>
 <dd>Returns <code>1</code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js line-numbers  language-js"><code class="language-js"><span class="keyword token">const</span> queueingStrategy <span class="operator token">=</span> <span class="keyword token">new</span> <span class="class-name token">CountQueuingStrategy</span><span class="punctuation token">(</span><span class="punctuation token">{</span> highWaterMark<span class="punctuation token">:</span> <span class="number token">1</span> <span class="punctuation token">}</span><span class="punctuation token">)</span><span class="punctuation token">;</span>

<span class="keyword token">const</span> writableStream <span class="operator token">=</span> <span class="keyword token">new</span> <span class="class-name token">WritableStream</span><span class="punctuation token">(</span><span class="punctuation token">{</span>
  <span class="comment token">// Implement the sink</span>
  <span class="function token">write</span><span class="punctuation token">(</span>chunk<span class="punctuation token">)</span> <span class="punctuation token">{</span>
    <span class="punctuation token">...</span>
  <span class="punctuation token">}</span><span class="punctuation token">,</span>
  <span class="function token">close</span><span class="punctuation token">(</span><span class="punctuation token">)</span> <span class="punctuation token">{</span>
    ...
  <span class="punctuation token">}</span><span class="punctuation token">,</span>
  <span class="function token">abort</span><span class="punctuation token">(</span>err<span class="punctuation token">)</span> <span class="punctuation token">{</span>
    console<span class="punctuation token">.</span><span class="function token">log</span><span class="punctuation token">(</span><span class="string token">"Sink error:"</span><span class="punctuation token">,</span> err<span class="punctuation token">)</span><span class="punctuation token">;</span>
  <span class="punctuation token">}</span>
<span class="punctuation token">}</span><span class="punctuation token">,</span> queueingStrategy<span class="punctuation token">)</span><span class="punctuation token">;

var size = queueingStrategy.size()</span></code>;
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Streams','#cqs-class','CountQueuingStrategy')}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.CountQueuingStrategy")}}</p>
</div>
